Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.openjpa.jdbc.sql
Interface Result

All Superinterfaces:
  Closeable

All Known Implementing Classes:
  AbstractResult, MergedResult, ResultSetResult, SelectImpl.SelectResult

    public interface Result

extends Closeable

A result from the execution of a query or stored procedure. This interface is aligned closely with the `ResultSet`, so you can expect like-named methods to have similar semantics. However, the interface has been distilled and simplified, so a result object could easily mask information sources other than a result set. For more flexible customization of data loading, see the `PCResultObjectProvider`.

Author:
  Abe White
See Also:
  `ResultSetResult`

Method Summary
`boolean` | `absolute(int row)` Move to the given 0-based row in the result, or return false if the row does not exist.
`void` | `close()` Free the resources used by this result; do not close the SQL connection.
`boolean` | `contains(Column col, Joins joins)` Return true if the given column is available in the result.
`boolean` | `contains(Object obj)` Return true if the given id or column is available in the result.
`boolean` | `containsAll(Column[] cols, Joins joins)` Return true if all the given columns are available in the result.
`boolean` | `containsAll(Object[] objs)` Return true if all the given ids or columns are available in the result.
`void` | `endDataRequest()` Ends a data request.
`Array` | `getArray(Column col, Joins joins)` Return the value stored in the given column; may not be supported by results that are not backed by a SQL result set.
`Array` | `getArray(Object obj)` Return the value stored in the given column or id; may not be supported by results that are not backed by a SQL result set.
`InputStream` | `getAsciiStream(Column col, Joins joins)` Return the value stored in the given column; may not be supported by results that are not backed by a SQL result set.
`InputStream` | `getAsciiStream(Object obj)` Return the value stored in the given column or id; may not be supported by results that are not backed by a SQL result set.
`ClassMapping` | `getBaseMapping()` If this is the result of a UNION used to select a hierarchy of mappings, the base mapping represented by the current row.
`BigDecimal` | `getBigDecimal(Column col, Joins joins)` Return the value stored in the given column.
`BigDecimal` | `getBigDecimal(Object obj)` Return the value stored in the given column or id.
`BigInteger` | `getBigInteger(Column col, Joins joins)` Return the value stored in the given column.
`BigInteger` | `getBigInteger(Object obj)` Return the value stored in the given column or id.
`InputStream` | `getBinaryStream(Column col, Joins joins)` Return the value stored in the given column; may not be supported by results that are not backed by a SQL result set.
`InputStream` | `getBinaryStream(Object obj)` Return the value stored in the given column or id; may not be supported by results that are not backed by a SQL result set.
`Blob` | `getBlob(Column col, Joins joins)` Return the value stored in the given column; may not be supported by results that are not backed by a SQL result set.
`Blob` | `getBlob(Object obj)` Return the value stored in the given column or id; may not be supported by results that are not backed by a SQL result set.
`boolean` | `getBoolean(Column col, Joins joins)` Return the value stored in the given column.
`boolean` | `getBoolean(Object obj)` Return the value stored in the given column or id.
`byte` | `getByte(Column col, Joins joins)` Return the value stored in the given column.
`byte` | `getByte(Object obj)` Return the value stored in the given column or id.
`byte[]` | `getBytes(Column col, Joins joins)` Return the value stored in the given column; may not be supported by results that are not backed by a SQL result set.
`byte[]` | `getBytes(Object obj)` Return the value stored in the given column or id; may not be supported by results that are not backed by a SQL result set.
`Calendar` | `getCalendar(Column col, Joins joins)` Return the value stored in the given column.
`Calendar` | `getCalendar(Object obj)` Return the value stored in the given column or id.
`char` | `getChar(Column col, Joins joins)` Return the value stored in the given column.
`char` | `getChar(Object obj)` Return the value stored in the given column or id.
`Reader` | `getCharacterStream(Column col, Joins joins)` Return the value stored in the given column; may not be supported by results that are not backed by a SQL result set.
`Reader` | `getCharacterStream(Object obj)` Return the value stored in the given column or id; may not be supported by results that are not backed by a SQL result set.
`Clob` | `getClob(Column col, Joins joins)` Return the value stored in the given column; may not be supported by results that are not backed by a SQL result set.
`Clob` | `getClob(Object obj)` Return the value stored in the given column or id; may not be supported by results that are not backed by a SQL result set.
`Date` | `getDate(Column col, Calendar cal, Joins joins)` Return the value stored in the given column; may not be supported by results that are not backed by a SQL result set.
`Date` | `getDate(Column col, Joins joins)` Return the value stored in the given column.
`Date` | `getDate(Object obj)` Return the value stored in the given column or id.
`Date` | `getDate(Object obj, Calendar cal)` Return the value stored in the given column or id; may not be supported by results that are not backed by a SQL result set.
`double` | `getDouble(Column col, Joins joins)` Return the value stored in the given column.
`double` | `getDouble(Object obj)` Return the value stored in the given column or id.
`Object` | `getEager(FieldMapping key)` The eager result for the given key, or null if none.
`float` | `getFloat(Column col, Joins joins)` Return the value stored in the given column.
`float` | `getFloat(Object obj)` Return the value stored in the given column or id.
`int` | `getInt(Column col, Joins joins)` Return the value stored in the given column.
`int` | `getInt(Object obj)` Return the value stored in the given column or id.
`InputStream` | `getLOBStream(JDBCStore store, Object obj)`
`Locale` | `getLocale(Column col, Joins joins)` Return the value stored in the given column.
`Locale` | `getLocale(Object obj)` Return the value stored in the given column or id.
`long` | `getLong(Column col, Joins joins)` Return the value stored in the given column.
`long` | `getLong(Object obj)` Return the value stored in the given column or id.
`FieldMapping` | `getMappedByFieldMapping()` If this is the result used to select a toMany relationship, the mappedByFieldMapping is field mapping representing the inverse relationship.
`Object` | `getMappedByValue()` If this is the result used to select a toMany relationship, the mappedByValue is value of the owner of the toMany relationship.
`Number` | `getNumber(Column col, Joins joins)` Return the value stored in the given column.
`Number` | `getNumber(Object obj)` Return the value stored in the given column or id.
`Object` | `getObject(Column col, Object arg, Joins joins)` Return the value stored in the given column.
`Object` | `getObject(Object obj, int metaType, Object arg)` Return the value stored in the given column or id.
`Ref` | `getRef(Column col, Map map, Joins joins)` Return the value stored in the given column; may not be supported by results that are not backed by a SQL result set.
`Ref` | `getRef(Object obj, Map map)` Return the value stored in the given column or id; may not be supported by results that are not backed by a SQL result set.
`short` | `getShort(Column col, Joins joins)` Return the value stored in the given column.
`short` | `getShort(Object obj)` Return the value stored in the given column or id.
`Object` | `getSQLObject(Column col, Map map, Joins joins)` Return the value stored in the given column; may not be supported by results that are not backed by a SQL result set.
`Object` | `getSQLObject(Object obj, Map map)` Return the value stored in the given column or id; may not be supported by results that are not backed by a SQL result set.
`String` | `getString(Column col, Joins joins)` Return the value stored in the given column.
`String` | `getString(Object obj)` Return the value stored in the given column or id.
`Time` | `getTime(Column col, Calendar cal, Joins joins)` Return the value stored in the given column; may not be supported by results that are not backed by a SQL result set.
`Time` | `getTime(Object obj, Calendar cal)` Return the value stored in the given column or id; may not be supported by results that are not backed by a SQL result set.
`Timestamp` | `getTimestamp(Column col, Calendar cal, Joins joins)` Return the value stored in the given column; may not be supported by results that are not backed by a SQL result set.
`Timestamp` | `getTimestamp(Object obj, Calendar cal)` Return the value stored in the given column or id; may not be supported by results that are not backed by a SQL result set.
`int` | `indexOf()` The index of the select within the UNION that the current row corresponds to, or 0.
`boolean` | `isLocking()` If true, then any results loaded from this Result will be locked in the database.
`Object` | `load(ClassMapping mapping, JDBCStore store, JDBCFetchConfiguration fetch)` Load a pc object using the given store manager.
`Object` | `load(ClassMapping mapping, JDBCStore store, JDBCFetchConfiguration fetch, Joins joins)` Load a pc object using the given store manager.
`Joins` | `newJoins()` Return a new joins instance to use for traversing to related data.
`boolean` | `next()` Advance to the next row, or return false if there are no more rows in the result.
`void` | `pushBack()` Push back the last result.
`void` | `putEager(FieldMapping key, Object res)` The eager result for the given key, or null if none.
`void` | `setBaseMapping(ClassMapping mapping)` If this is the result of a UNION used to select a hierarchy of mappings, the base mapping represented by the current row.
`void` | `setLocking(boolean locking)` Set to true if row locking has been issued for the row.
`void` | `setMappedByFieldMapping(FieldMapping fieldMapping)` If this is the result used to select a toMany relationship, the mappedByFieldMapping is field mapping representing the inverse relationship.
`void` | `setMappedByValue(Object mappedByValue)` If this is the result used to select a toMany relationship, the mappedByValue is value of the owner of the toMany relationship.
`int` | `size()` Return the number of rows in this result.
`void` | `startDataRequest(Object mapping)` Informs this receiver about the application element for which a subsequent data request will be made.
`boolean` | `supportsRandomAccess()` Return true if the result supports random access.
`boolean` | `wasNull()` Return true if the last value fetched was null.

Method Detail

### getEager

    Object getEager(FieldMapping key)

  The eager result for the given key, or null if none.

### putEager

    void putEager(FieldMapping key,
                  Object res)

  The eager result for the given key, or null if none.

### newJoins

    Joins newJoins()

  Return a new joins instance to use for traversing to related data.

### close

    void close()

  Free the resources used by this result; do not close the SQL connection.

  Specified by:
    `close` in interface `Closeable`

### setLocking

    void setLocking(boolean locking)

  Set to true if row locking has been issued for the row.

### isLocking

    boolean isLocking()

  If true, then any results loaded from this Result will be locked in the database.

### supportsRandomAccess

    boolean supportsRandomAccess()
                                 throws SQLException

  Return true if the result supports random access.

  Throws:
    `SQLException`

### absolute

    boolean absolute(int row)
                     throws SQLException

  Move to the given 0-based row in the result, or return false if the row does not exist. This method will only be called if the result supports random access.

  Throws:
    `SQLException`

### next

    boolean next()
                 throws SQLException

  Advance to the next row, or return false if there are no more rows in the result.

  Throws:
    `SQLException`

### pushBack

    void pushBack()
                  throws SQLException

  Push back the last result. In other words, just ignore the next call to `next()`. After the first time this method is called, additional calls before a call to `next()` or `absolute(int)` should have no further affect.

  Throws:
    `SQLException`

### size

    int size()
             throws SQLException

  Return the number of rows in this result.

  Throws:
    `SQLException`

### contains

    boolean contains(Object obj)
                     throws SQLException

  Return true if the given id or column is available in the result.

  Throws:
    `SQLException`

### containsAll

    boolean containsAll(Object[] objs)
                        throws SQLException

  Return true if all the given ids or columns are available in the result.

  Throws:
    `SQLException`

### contains

    boolean contains(Column col,
                     Joins joins)
                     throws SQLException

  Return true if the given column is available in the result.

  Throws:
    `SQLException`

### containsAll

    boolean containsAll(Column[] cols,
                        Joins joins)
                        throws SQLException

  Return true if all the given columns are available in the result.

  Throws:
    `SQLException`

### getBaseMapping

    ClassMapping getBaseMapping()

  If this is the result of a UNION used to select a hierarchy of mappings, the base mapping represented by the current row. This information is not available after getting any eager results from the row.

### setBaseMapping

    void setBaseMapping(ClassMapping mapping)

  If this is the result of a UNION used to select a hierarchy of mappings, the base mapping represented by the current row. This information is not available after getting any eager results from the row.

### getMappedByFieldMapping

    FieldMapping getMappedByFieldMapping()

  If this is the result used to select a toMany relationship, the mappedByFieldMapping is field mapping representing the inverse relationship. This is to avoid unneeded extra sql to retrieve the eager inverse field.

### setMappedByFieldMapping

    void setMappedByFieldMapping(FieldMapping fieldMapping)

  If this is the result used to select a toMany relationship, the mappedByFieldMapping is field mapping representing the inverse relationship. This is to avoid unneeded extra sql to retrieve the eager inverse field.

### getMappedByValue

    Object getMappedByValue()

  If this is the result used to select a toMany relationship, the mappedByValue is value of the owner of the toMany relationship. This is to avoid unneeded extra sql to retrieve the eager inverse field.

### setMappedByValue

    void setMappedByValue(Object mappedByValue)

  If this is the result used to select a toMany relationship, the mappedByValue is value of the owner of the toMany relationship. This is to avoid unneeded extra sql to retrieve the eager inverse field.

### indexOf

    int indexOf()

  The index of the select within the UNION that the current row corresponds to, or 0.

### load

    Object load(ClassMapping mapping,
                JDBCStore store,
                JDBCFetchConfiguration fetch)
                throws SQLException

  Load a pc object using the given store manager.

  Throws:
    `SQLException`

### load

    Object load(ClassMapping mapping,
                JDBCStore store,
                JDBCFetchConfiguration fetch,
                Joins joins)
                throws SQLException

  Load a pc object using the given store manager.

  Throws:
    `SQLException`

### getArray

    Array getArray(Object obj)
                   throws SQLException

  Return the value stored in the given column or id; may not be supported by results that are not backed by a SQL result set.

  Throws:
    `SQLException`

### getAsciiStream

    InputStream getAsciiStream(Object obj)
                               throws SQLException

  Return the value stored in the given column or id; may not be supported by results that are not backed by a SQL result set.

  Throws:
    `SQLException`

### getBigDecimal

    BigDecimal getBigDecimal(Object obj)
                             throws SQLException

  Return the value stored in the given column or id.

  Throws:
    `SQLException`

### getBigInteger

    BigInteger getBigInteger(Object obj)
                             throws SQLException

  Return the value stored in the given column or id.

  Throws:
    `SQLException`

### getBinaryStream

    InputStream getBinaryStream(Object obj)
                                throws SQLException

  Return the value stored in the given column or id; may not be supported by results that are not backed by a SQL result set.

  Throws:
    `SQLException`

### getLOBStream

    InputStream getLOBStream(JDBCStore store,
                             Object obj)
                             throws SQLException

  Throws:
    `SQLException`

### getBlob

    Blob getBlob(Object obj)
                 throws SQLException

  Return the value stored in the given column or id; may not be supported by results that are not backed by a SQL result set.

  Throws:
    `SQLException`

### getBoolean

    boolean getBoolean(Object obj)
                       throws SQLException

  Return the value stored in the given column or id.

  Throws:
    `SQLException`

### getByte

    byte getByte(Object obj)
                 throws SQLException

  Return the value stored in the given column or id.

  Throws:
    `SQLException`

### getBytes

    byte[] getBytes(Object obj)
                    throws SQLException

  Return the value stored in the given column or id; may not be supported by results that are not backed by a SQL result set.

  Throws:
    `SQLException`

### getCalendar

    Calendar getCalendar(Object obj)
                         throws SQLException

  Return the value stored in the given column or id.

  Throws:
    `SQLException`

### getChar

    char getChar(Object obj)
                 throws SQLException

  Return the value stored in the given column or id.

  Throws:
    `SQLException`

### getCharacterStream

    Reader getCharacterStream(Object obj)
                              throws SQLException

  Return the value stored in the given column or id; may not be supported by results that are not backed by a SQL result set.

  Throws:
    `SQLException`

### getClob

    Clob getClob(Object obj)
                 throws SQLException

  Return the value stored in the given column or id; may not be supported by results that are not backed by a SQL result set.

  Throws:
    `SQLException`

### getDate

    Date getDate(Object obj)
                 throws SQLException

  Return the value stored in the given column or id.

  Throws:
    `SQLException`

### getDate

    Date getDate(Object obj,
                 Calendar cal)
                 throws SQLException

  Return the value stored in the given column or id; may not be supported by results that are not backed by a SQL result set.

  Throws:
    `SQLException`

### getDouble

    double getDouble(Object obj)
                     throws SQLException

  Return the value stored in the given column or id.

  Throws:
    `SQLException`

### getFloat

    float getFloat(Object obj)
                   throws SQLException

  Return the value stored in the given column or id.

  Throws:
    `SQLException`

### getInt

    int getInt(Object obj)
               throws SQLException

  Return the value stored in the given column or id.

  Throws:
    `SQLException`

### getLocale

    Locale getLocale(Object obj)
                     throws SQLException

  Return the value stored in the given column or id.

  Throws:
    `SQLException`

### getLong

    long getLong(Object obj)
                 throws SQLException

  Return the value stored in the given column or id.

  Throws:
    `SQLException`

### getNumber

    Number getNumber(Object obj)
                     throws SQLException

  Return the value stored in the given column or id.

  Throws:
    `SQLException`

### getObject

    Object getObject(Object obj,
                     int metaType,
                     Object arg)
                     throws SQLException

  Return the value stored in the given column or id.

  Parameters:
    `obj` - the column or id whose data to fetch
    `metaType` - the type code from `JavaTypes` or `JavaSQLTypes` for the type of the data; if `obj` is a column, you may specify -1 to use the column's recorded java type
    `arg` - some JDBC data access methods use an argument, such as a `Calendar` or `Map`
  Throws:
    `SQLException`

### getSQLObject

    Object getSQLObject(Object obj,
                        Map map)
                        throws SQLException

  Return the value stored in the given column or id; may not be supported by results that are not backed by a SQL result set.

  Throws:
    `SQLException`

### getRef

    Ref getRef(Object obj,
               Map map)
               throws SQLException

  Return the value stored in the given column or id; may not be supported by results that are not backed by a SQL result set.

  Throws:
    `SQLException`

### getShort

    short getShort(Object obj)
                   throws SQLException

  Return the value stored in the given column or id.

  Throws:
    `SQLException`

### getString

    String getString(Object obj)
                     throws SQLException

  Return the value stored in the given column or id.

  Throws:
    `SQLException`

### getTime

    Time getTime(Object obj,
                 Calendar cal)
                 throws SQLException

  Return the value stored in the given column or id; may not be supported by results that are not backed by a SQL result set.

  Throws:
    `SQLException`

### getTimestamp

    Timestamp getTimestamp(Object obj,
                           Calendar cal)
                           throws SQLException

  Return the value stored in the given column or id; may not be supported by results that are not backed by a SQL result set.

  Throws:
    `SQLException`

### getArray

    Array getArray(Column col,
                   Joins joins)
                   throws SQLException

  Return the value stored in the given column; may not be supported by results that are not backed by a SQL result set.

  Throws:
    `SQLException`

### getAsciiStream

    InputStream getAsciiStream(Column col,
                               Joins joins)
                               throws SQLException

  Return the value stored in the given column; may not be supported by results that are not backed by a SQL result set.

  Throws:
    `SQLException`

### getBigDecimal

    BigDecimal getBigDecimal(Column col,
                             Joins joins)
                             throws SQLException

  Return the value stored in the given column.

  Throws:
    `SQLException`

### getBigInteger

    BigInteger getBigInteger(Column col,
                             Joins joins)
                             throws SQLException

  Return the value stored in the given column.

  Throws:
    `SQLException`

### getBinaryStream

    InputStream getBinaryStream(Column col,
                                Joins joins)
                                throws SQLException

  Return the value stored in the given column; may not be supported by results that are not backed by a SQL result set.

  Throws:
    `SQLException`

### getBlob

    Blob getBlob(Column col,
                 Joins joins)
                 throws SQLException

  Return the value stored in the given column; may not be supported by results that are not backed by a SQL result set.

  Throws:
    `SQLException`

### getBoolean

    boolean getBoolean(Column col,
                       Joins joins)
                       throws SQLException

  Return the value stored in the given column.

  Throws:
    `SQLException`

### getByte

    byte getByte(Column col,
                 Joins joins)
                 throws SQLException

  Return the value stored in the given column.

  Throws:
    `SQLException`

### getBytes

    byte[] getBytes(Column col,
                    Joins joins)
                    throws SQLException

  Return the value stored in the given column; may not be supported by results that are not backed by a SQL result set.

  Throws:
    `SQLException`

### getCalendar

    Calendar getCalendar(Column col,
                         Joins joins)
                         throws SQLException

  Return the value stored in the given column.

  Throws:
    `SQLException`

### getChar

    char getChar(Column col,
                 Joins joins)
                 throws SQLException

  Return the value stored in the given column.

  Throws:
    `SQLException`

### getCharacterStream

    Reader getCharacterStream(Column col,
                              Joins joins)
                              throws SQLException

  Return the value stored in the given column; may not be supported by results that are not backed by a SQL result set.

  Throws:
    `SQLException`

### getClob

    Clob getClob(Column col,
                 Joins joins)
                 throws SQLException

  Return the value stored in the given column; may not be supported by results that are not backed by a SQL result set.

  Throws:
    `SQLException`

### getDate

    Date getDate(Column col,
                 Joins joins)
                 throws SQLException

  Return the value stored in the given column.

  Throws:
    `SQLException`

### getDate

    Date getDate(Column col,
                 Calendar cal,
                 Joins joins)
                 throws SQLException

  Return the value stored in the given column; may not be supported by results that are not backed by a SQL result set.

  Throws:
    `SQLException`

### getDouble

    double getDouble(Column col,
                     Joins joins)
                     throws SQLException

  Return the value stored in the given column.

  Throws:
    `SQLException`

### getFloat

    float getFloat(Column col,
                   Joins joins)
                   throws SQLException

  Return the value stored in the given column.

  Throws:
    `SQLException`

### getInt

    int getInt(Column col,
               Joins joins)
               throws SQLException

  Return the value stored in the given column.

  Throws:
    `SQLException`

### getLocale

    Locale getLocale(Column col,
                     Joins joins)
                     throws SQLException

  Return the value stored in the given column.

  Throws:
    `SQLException`

### getLong

    long getLong(Column col,
                 Joins joins)
                 throws SQLException

  Return the value stored in the given column.

  Throws:
    `SQLException`

### getNumber

    Number getNumber(Column col,
                     Joins joins)
                     throws SQLException

  Return the value stored in the given column.

  Throws:
    `SQLException`

### getObject

    Object getObject(Column col,
                     Object arg,
                     Joins joins)
                     throws SQLException

  Return the value stored in the given column.

  Parameters:
    `col` - the column whose data to fetch
    `arg` - some JDBC data access methods use an argument, such as a `Calendar` or `Map`
  Throws:
    `SQLException`

### getSQLObject

    Object getSQLObject(Column col,
                        Map map,
                        Joins joins)
                        throws SQLException

  Return the value stored in the given column; may not be supported by results that are not backed by a SQL result set.

  Throws:
    `SQLException`

### getRef

    Ref getRef(Column col,
               Map map,
               Joins joins)
               throws SQLException

  Return the value stored in the given column; may not be supported by results that are not backed by a SQL result set.

  Throws:
    `SQLException`

### getShort

    short getShort(Column col,
                   Joins joins)
                   throws SQLException

  Return the value stored in the given column.

  Throws:
    `SQLException`

### getString

    String getString(Column col,
                     Joins joins)
                     throws SQLException

  Return the value stored in the given column.

  Throws:
    `SQLException`

### getTime

    Time getTime(Column col,
                 Calendar cal,
                 Joins joins)
                 throws SQLException

  Return the value stored in the given column; may not be supported by results that are not backed by a SQL result set.

  Throws:
    `SQLException`

### getTimestamp

    Timestamp getTimestamp(Column col,
                           Calendar cal,
                           Joins joins)
                           throws SQLException

  Return the value stored in the given column; may not be supported by results that are not backed by a SQL result set.

  Throws:
    `SQLException`

### wasNull

    boolean wasNull()
                    throws SQLException

  Return true if the last value fetched was null.

  Throws:
    `SQLException`

### startDataRequest

    void startDataRequest(Object mapping)

  Informs this receiver about the application element for which a subsequent data request will be made.

### endDataRequest

    void endDataRequest()

  Ends a data request. Must be called in conjunction with `startDataRequest(java.lang.Object)`. The calls can be nested as follws

       startDataRequest (relation); startDataRequest (relationsField);
       getObject("COLUMN_Y"); endDataRequest (); endDataRequest ();

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2006-2013 Apache Software Foundation. All Rights Reserved.